using System;
using ProtoBuf;
using Fantasy;
using System.Linq;
using System.Reflection;
using System.Collections.Generic;
using System.Collections.Concurrent;
using Fantasy.Serialize;
using Fantasy.ConfigTable;

namespace NBF
{
    [ProtoContract]
    public sealed partial class BobberConfig : ASerialize, IProto, IConfigTable
    {
    
		[ProtoMember(1)]
		public uint Id { get; set; } // Id
		[ProtoMember(2)]
		public string Model { get; set; } // 模型
		[ProtoMember(3)]
		public uint Type { get; set; } // 类型
		[ProtoMember(4)]
		public uint Weight { get; set; } // 重量(克)
		[ProtoMember(5)]
		public uint Displacement { get; set; } // 位移
		[ProtoMember(6)]
		public uint NightLight { get; set; } // 是否夜光  
        [ProtoIgnore]
        public uint Key => Id;
        
        #region Static
        
        private static ConfigContext<BobberConfig> Context => ConfigTableHelper.Table<BobberConfig>();

        public static BobberConfig Get(uint key)
        {
            return Context.Get(key);
        }

        public static BobberConfig Get(Predicate<BobberConfig> match)
        {
            return Context.Get(match);
        }
        
        public static BobberConfig Fist()
        {
            return Context.Fist();
        }

        public static BobberConfig Last()
        {
            return Context.Last();
        }

        public static BobberConfig Fist(Predicate<BobberConfig> match)
        {
            return Context.Fist(match);
        }

        public static BobberConfig Last(Predicate<BobberConfig> match)
        {
            return Context.Last(match);
        }
        
        public static int Count()
        {
            return Context.Count();
        }

        public static int Count(Func<BobberConfig, bool> predicate)
        {
            return Context.Count(predicate);
        }

        public static List<BobberConfig> GetList()
        {
            return Context.GetList();
        }

        public static List<BobberConfig> GetList(Predicate<BobberConfig> match)
        {
            return Context.GetList(match);
        }
        public static void ParseJson(Newtonsoft.Json.Linq.JArray arr)
        {
            ConfigTableHelper.ParseLine<BobberConfig>(arr);
        }
        #endregion
    }
}